Tutorial is loading...

Tutorial is loading...

Tutorial is loading...

Tutorial is loading...

Tutorial is loading...

Please subscribe to the official Codeforces channel in Telegram via the link: https://t.me/codeforces_official.
×

# | User | Rating |
---|---|---|

1 | tourist | 3372 |

2 | Radewoosh | 3353 |

3 | OO0OOO00O0OOO0O0…O | 3264 |

4 | V--o_o--V | 3247 |

5 | scott_wu | 3168 |

6 | Benq | 3154 |

7 | mnbvmar | 3143 |

8 | Petr | 3139 |

8 | ksun48 | 3139 |

10 | LHiC | 3118 |

# | User | Contrib. |
---|---|---|

1 | Radewoosh | 195 |

2 | Errichto | 175 |

3 | rng_58 | 159 |

4 | Ashishgup | 157 |

5 | neal | 156 |

6 | tourist | 154 |

7 | PikMike | 151 |

8 | Petr | 150 |

8 | Um_nik | 150 |

10 | Swistakk | 147 |

10 | kostka | 147 |

10 | Vovuh | 147 |

Tutorial is loading...

Tutorial is loading...

Tutorial is loading...

Tutorial is loading...

Tutorial is loading...

Tutorial of Codeforces Round #398 (Div. 2)

↑

↓

Codeforces (c) Copyright 2010-2018 Mike Mirzayanov

The only programming contests Web 2.0 platform

Server time: Dec/10/2018 08:33:38 (f2).

Desktop version, switch to mobile version.

Supported by

User lists

Name |
---|

Is there a specific reason for having

N= 10^{6}in the 3rd problem ? This makes it almost impossible to solve it in Java.I had 2 submissions with 100% idential complexity, number of iterations, the one in Java gave me TLE, the one in C++ gave me AC.

Good day to you,

well the reason might be (in my humble opinion) to get rid of O(Nlog(M)^2) solution (I've tried it and got TLE).

I know it is naive, yet if you (in each binary-search body) copy all possible elements and sort them (with some basic sort algorithm) you will get such complexity (and also TLE :P)

So that is what I imagine as reason

Good Luck & Have Nice Day ^_^

Problem C, and not D

Oh apologies, I simply can't read :'(

In this case, nothing reasonable came to my mind :/

For problem D, when

n=m=10^6 andt=10^7,O(n(logn)^2)is really same asO(tlogm). But to my surprise, the former get TLE!I wrote dfs using my own stack and got accept in 1 second in Java. But constraints are really bad :(

I totally agree with you!

My exactly the same algo (O(N)) got TLE in Java. Is it possible to get tests e.g. Test-12?

In problem A, it seems OK to have a trailing space at the end of a list of numbers. Is this standard in Codeforces (i.e., trailing spaces are ignored)?

By the way, I LOVED, LOVED problem A. It looked sooo clear and simple but I just couldn't wrap my brain around it until the very end. It was really infuriating!! And even then I didn't end up with the intended solution which was really beautiful.

"Implementation problems" are often just a bunch of boring details. This one was a real gem!

I think this solution is wrong but it passed.

I've already mentioned it here.

For D question,

I have an N *Ackermaninverse of N solution i feel. which is based on pure simulation with greedy.It is working because of poor systests or is it fine(Can anyone say what is the exact complexity of my solution)

code here

so weak tests(

Another solution for problem D: - First, store all the cartons you can buy at the store in a vector and sort them non-increasing.

Then, iterate all the possible dates from the biggest one down, store a value to keep track of the amount of cartons that needs to be drank in the current date. Let's call this value cur

If at a certain moment, cur > 0, that means we have drank enough from this day forward. Update our answer using the vector of milk cartons. This can be done by using a pointer.

Therefore, our total complexity is O(N log N + t)

For more details, here is the code

I got surprised to know that the intended solution uses the binary search. Many people actually did solve D using binary search.

My solution is O(n log n + m log m), due to the costs of sorting two input arrays. The solving part is in fact greedy and linear O(n + m).

The short description of the solution is as follows:

Link to the Java code

Hello, Can somebody please explain why my solution here receives a TLE, even if the solution complexity is the same as in the presented solution? Thank you :D

because you used cin without sync_with_stdio(false) and there are too many inputs. I added it to your solution and got accepted.

http://codeforces.com/contest/767/submission/24792608

Thank you, I didn't know it could make such a difference :D

maybe scanf for larger data is prefered?

yay! :) Then I can consider my

O(10^{7}+m) solution for D pretty good. :)Solution for B: ~~~~~ ~~~~~

So easy...

Can anyone help me understand why my solution to problem D is getting TLE???. I am pretty sure complexity is O(10^7+n+m). Shouldn't it get accepted???

My solution

Please help me.....

When dealing with large input size with C++, consider desyncing the IO stream by "ios_base::sync_with_stdio(false);", or use printf/scanf to improve IO time.

Wonderful!!!!!! Very much thank you.

Could you please explain it to me why and what happens by adding above statement in code??? I haven't came across such thing till now. Hope I don't sound stupid....

Hello, could someone write more detailed explanation of C problem, I still don't understand how the second case works, even though I took a look at a couple of solutions and read the editorial.

Any help would be greatly appreciated, thanks!

The first sample in the problem is illustrating the second case, which

v_{1}= 1 andv_{2}= 4. As you can see, neitherv_{1}norv_{2}is the ancestor of other. Also,s_{1}=s_{4}= 5 =x/ 3. You can take a look at the explanation below the statement.Can somebody please help me in question C.I have created a tree and used recursive calls to find sum.Implementation is O(n) but still it gets time limit exceeded in Testcase 12. Please check my solution and tell me the problem please. Code is with proper comments. Thanks http://codeforces.com/contest/767/submission/24804939

Try changing all cin/cout with scanf/printf ...

See my these two submissions -

24812029 TLE in test 12

24812043 AC after using scanf/printf

:)

The solution is much more simple that the author's. Do DFS from root node, and for every subtree, can calculate the total heat using regular tree DP. Then, when returning the value, if the total heat of subtree is equal to total heat of whole three / 3 then set to 0 in order to avoid double counting. Code explains the concept much better than words, in my opinion.

Code: 24764409

Magical Solution! :D

so smart!

In problem C, Both cases can be handled by this trick —

"While calculating sub tree sums, If you find a node with sub_tree_sum == sum/3 then do not add this sum to it's ancestors :D"

This will solve the first case as well as second case.

Now you just need to find just 2 such nodes :) Which can be memorized while calculating the sums. If if we can't find at least 2 such nodes then there is no solution.

My Code — 24812043

Ques C was a nice Question . Given it was direct but few tricks involved .

I tried solving D using binary search similar to what was described in this editorial but I still get TLE.

My submission can be found here. It's time complexity is

`logm * (`

`n + m (for merging) + n + m (for checking if we can buy middle cartons)`

`)`

so I don't see why it get TLE.Any ideas?

427896

Why is my C WAing?